#include<reg51.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<rtx51tny.h>

#define RECEIVE		0
#define	SENDING		1
#define	CHARGES		2
#define	BLINK		3

#define K		10			//Pre 10ms TICK je 1 a pre 1ms TICK je 10 !!!
#define	VALUE	0x03

#define POCET(pole)       (unsigned char)(sizeof(pole))/((sizeof(*pole)))	//Zisti pocet prvkov pola
#define SIZE(pole,index)  (unsigned char)(strlen(pole[index]))				//Zisti velkost prvku pola s indexom

extern void Init_Serial(void);

enum {ON=0, OFF=1}	STATES;

sbit RED	= P1^3;
sbit ORANGE	= P1^4;
sbit GREEN	= P1^5;
sbit CHARGE	= P3^7;
sbit TXD_LED= P1^7;
sbit RXD_LED= P1^6;

sbit Tlac	= P3^2;
sbit Logo	= P3^3;

//-----------------------------------------------------------------------------------------------------------------------------
//code char *Info[]= {"Compiled file: "__FILE__," with KEIL Software C51 ver. 8.08, Day: "__DATE2__," Time: ",__TIME__};
//code char *Logo[]= {"*****************************************************************************\n",
//				    "*  Author: Eduard Jadron, Jilemnickeho 37/46 *\n",
//				    "*      Copyright (c) 2014 All Rights Reserved for Diversant Software        *\n",
//				    "*****************************************************************************\n"};
//-----------------------------------------------------------------------------------------------------------------------------

data char Buffer[25];		//data char Buffer[25];
code char *TEL[]={"+CLIP: 0907000000","+CLIP: 0907000000","+CLIP: 0907000000","+CLIP: 0907000000"};
code char DIALTONE[]="NO DIALTONE";
code char CARRIER[]="NO CARRIER";
code char ERROR[]="ERROR";
code char RING[]="RING";
code char BUSY[]="BUSY";
code char OK[]="OK";

data unsigned char EVENTS;

#define EVENT_OK   	0x01
#define EVENT_ERROR 0x02
#define EVENT_RING 	0x04
#define EVENT_BATT	0x08
#define EVENT_TEL		0x10
#define EVENT_BUSY	0x20

void Int_RS232(void) interrupt 4 //using 2
{
 if(RI==1) 
  {
   RI=0; 
   RXD_LED=ON; 
   isr_send_signal(RECEIVE); 
   RXD_LED=OFF;
   } 
    else 
	 {
	  TI=0;
	  TXD_LED=ON;
	  isr_send_signal(SENDING);
	  TXD_LED=OFF;
	 }
}

void Send(char *String)
{
 do
  {
   SBUF=*String;
   os_wait(K_SIG,0xFF,NULL);
  }
 while(*String++!='\r');
 os_wait(K_TMO,K*25,NULL);
}

void Sekunda(void) //reentrant
{
 os_wait(K_TMO,K*25,NULL);
 os_wait(K_TMO,K*25,NULL);
 os_wait(K_TMO,K*25,NULL);
 os_wait(K_TMO,K*25,NULL);
}

unsigned char Battery = 100;

void Blink(void) _task_ BLINK
{
 while(1)
  {
   os_wait(K_TMO,K*25,NULL);
   switch((int)Battery)
    {
	  case	20	:	
	  case	40	:	RED=ON;    os_switch_task(); RED=OFF;    break;
	  case	60	:	ORANGE=ON; os_switch_task(); ORANGE=OFF; break;
	  case	80	:	
	  case	100	:	GREEN=ON;  os_switch_task(); GREEN=OFF;  break;
	  default	:	RED=GREEN=ORANGE=ON; 
	  				os_wait(K_TMO,1,NULL);
					RED=GREEN=ORANGE=OFF; 
					break;
	}
  }
}

#define Pocet 20

bdata Flags;
sbit Flag_Charge = Flags^0;
sbit Flag_Send   = Flags^1;

void Sending(void) _task_ SENDING
{
 unsigned char Countdown, Time;
 P3&=~VALUE;
 os_wait(K_TMO,K*25,NULL);
 P3|=VALUE;
 EVENTS=0x00;
 Flag_Send=OFF;
 Send("ATE0\r");
 Send("ATZ\r");
 Send("ATQ0\r");        //ATQ1 zapina OK a ERROR !!!
 Send("ATV1\r");
// Send("AT+CGSN\r");		//IMEI v AT89C4051 robi chybu a nenacitava dalsie AT prikazy !
 Send("AT+CMUT=0\r");
 Send("AT+CLIP=1\r");
 Send("AT+CALM=1\r");   //Alert Sound Mode 0,1,2
 Send("AT+CVIB=0\r");   //Vibration ringing
 Send("AT+CRSL=5\r");   //Level of ringing 1-5
 Send("AT+CLIP=1\r");	//CLIP
 os_wait(K_TMO,K*25,NULL);
 while(1) 
  {
   switch(os_wait(K_TMO+K_SIG,K*10,NULL))
    {
	 case	TMO_EVENT	:	if((++Time>=100)&&(CHARGE==OFF)) {Time=0x00; Send("AT+CBC\r");} 
	 						if(Tlac==ON) Countdown--; else {Countdown=Pocet; Flag_Send=OFF;}
	 						if((Countdown==0x00)&&(Flag_Send==OFF))
							 {
							  os_delete_task(CHARGES);
							  P3|=VALUE;
							  Sekunda();
							  Flag_Send=ON;
							  Send("ATDT*31#0915534339;\r");
							  Countdown=Pocet;
							 }
	 						break;
	 case	SIG_EVENT	:	if(EVENTS&EVENT_RING) {EVENTS&=~EVENT_RING; Flag_Send=OFF; P1^=0x80;}
							if(EVENTS&EVENT_TEL) {EVENTS&=~EVENT_TEL; Flag_Send=OFF; P1^=0x40;}
							if(EVENTS&EVENT_OK) EVENTS&=~EVENT_OK;
							break;
	}
  }
}

void Receive(void) _task_ RECEIVE
{
 unsigned char index,i,temp;
 Init_Serial();
 P3|=VALUE;
 Sekunda();
 os_create_task(SENDING);
 os_create_task(BLINK);
 os_wait(K_TMO,K*25,NULL);
 temp=SIZE(TEL,0);
 while(1) 
  {
   os_wait(K_SIG,0xFF,NULL);
   switch(Buffer[index]=SBUF)
    {
	 
	 case		'\r'	:	if(sscanf(Buffer,"+CBC: 0,%bd",&Battery)!=0){EVENTS|=EVENT_BATT; if(Battery<=20) os_create_task(CHARGES);}
							for(i=0x00; i<POCET(TEL); i++) if((memcmp(Buffer,TEL[i],temp))==0) EVENTS|=EVENT_TEL;
//							for(i=0x00; i<POCET(TEL); i++) if((memcmp(Buffer,TEL[i],SIZE(TEL,i)))==0) EVENTS|=EVENT_TEL;	//strlen v macro robi problemy zo zasobnikom a necita potom sscanf
							if(memcmp(Buffer,ERROR,sizeof(ERROR)-1)==0) {EVENTS|=EVENT_ERROR;}
							if(memcmp(Buffer,RING,sizeof(RING)-1)==0) 	{EVENTS|=EVENT_RING;}
							if(memcmp(Buffer,OK,sizeof(OK)-1)==0) 		{EVENTS|=EVENT_OK;}

							os_send_signal(SENDING);
	 case		'\n'	:	memset(Buffer,'\0',sizeof(Buffer));
							index=0x00;
							break;
	 default			:	if(index++>sizeof(Buffer)) index=0x00; 
	 						break;
	}
  }
}

void Charges(void) _task_ CHARGES
{
 unsigned int Time;
 while(1)
  {
 //  os_delete_task(SENDING);
   P3&=~VALUE;
   Sekunda();
   CHARGE=ON;
   Flag_Charge=ON;
   Time=36000;	//Waiting for 2.0 hour
   while(Time--) os_wait(K_TMO,K*20,NULL);
   CHARGE=OFF;
   Battery=100;
   P3|=VALUE;
   Sekunda();
//   os_create_task(SENDING);						//Ak je nabijanie spustene alebo vypnute nesmiem posielat na RS232 nic !!!
   Time =18000;	//Waiting for 1.0 hour
   while(Time--) os_wait(K_TMO,K*10,NULL);
   Flag_Charge=OFF;
   os_delete_task(CHARGES);
  }
}